//: Playground - noun: a place where people can play

import UIKit

enum ReadingMode {
    case day
    case evening
    case night
    
    var statusBarStyle: UIStatusBarStyle {
        switch self {
            case .day, .evening: return .default
            case .night: return .lightContent
        }
    }
    
    var headlineColor: UIColor {
        switch self {
        case .night: return UIColor(red: 1.0, green: 1.0, blue: 1.0, alpha: 1.0)
        case .evening, .day: return UIColor(red: 16/255.0, green: 16/255.0, blue: 16/255.0, alpha: 1.0)
        }
    }
    
    var dateColor: UIColor {
        switch self {
        case .day, .evening: return UIColor(red: 132/255.0, green: 132/255.0, blue: 132/255.0, alpha: 1.0)
        case .night: return UIColor(red: 151/255.0, green: 151/255.0, blue: 151/255.0, alpha: 1.0)
        }
    }
    
    var bodyTextColor: UIColor {
        switch self {
        case .day, .evening: return UIColor(red: 1.0, green: 1.0, blue: 1.0, alpha: 1.0)
        case .night: return UIColor(red: 151/255.0, green: 151/255.0, blue: 151/255.0, alpha: 1.0)
        }
    }
    
    var linkColor: UIColor {
        switch self {
        case .day, .evening: return UIColor(red: 68/255.0, green: 133/255.0, blue: 164/255.0, alpha: 1.0)
        case .night: return UIColor(red: 129/255.0, green: 161/255.0, blue: 166/255.0, alpha: 1.0)
        }
    }
}

let titleLabel = UILabel()

func readingViewWithMode(readingMode : ReadingMode){
    titleLabel.textColor = readingMode.headlineColor
}




