//: Playground - noun: a place where people can play

import UIKit

protocol PersonType {
    var firstName: String { get }
    var middleName: String? { get }
    var lastName: String { get }
    
    func fullName() -> String
    
    
}

extension PersonType {
    func fullName() -> String {
        return "\(firstName) \(middleName ?? "") \(lastName)"
    }
    
    func greeting() -> String {
        return "Hi, " + fullName()
    }
}


struct User: PersonType {
    let firstName: String
    let middleName: String?
    let lastName: String
    
    func greeting() -> String {
        return "Hey there, " + fullName()
    }
    
    func fullName() -> String {
        return "\(lastName), \(firstName)"
    }
 
}

let someUser = User(firstName: "Pasan", middleName: nil, lastName: "Premaratne")
let anotherUser: PersonType = User(firstName: "Gabe", middleName: nil, lastName: "Nadel")

someUser.greeting()
anotherUser.greeting()


struct Friend: PersonType {
    let firstName: String
    let middleName: String?
    let lastName: String
    
    func greeting() -> String {
        return "Hello, " + fullName()
    }
}

let someFriend = Friend(firstName: "Ben", middleName: nil, lastName: "Jakuben")

let people = [someUser, anotherUser, someFriend]



for person in people {
    print(person.greeting())
}




